-- Profession RPG created by A_Nolan, Yurek Ravenclaw					
local addonName, vars = ...					
local L = vars.L					
Profession_RP = vars					
local addon = Profession_RP					
local addonsls = "/PrRP"
local version = "6.2.0.15.06.25.04.34"
local settings					
--	8	(8)			
-- Array sets					
local defaults = {					
	enabled = true,				
	sound = true,				
	say = true,				
	summon = true,				
	link = false,				
	debug = false,				
	playfrequency = 5,				
	pet = 1,				
	list = 2,				
}					
					
local pet_n = {					
	[1] = {				
		[0] =	"magic",		
		[1] =	"BattlePet-0-00000486CF51",		
					
	},				
	[2] = {				
		[0] =	"mech",		
		[1] =	"BattlePet-0-00000486CE3C",		
					
	},				
	[3] = {				
		[0] =	"dragon",		
		[1] =	"BattlePet-0-00000486CE12",		
					
	},				
	[4] = {				
		[0] =	"undead",		
		[1] =	"BattlePet-0-00000486CE72",		
					
	},				
	[5] = {				
		[0] =	"elemental",		
		[1] =	"BattlePet-0-00000486CE91",		
					
	},				
}					
					
--	50	(42)			
local soundfiles = {					
	[1] = {				
		WEF_F_Agree	= {p=1, t=1},		
		WEF_F_Disagree	= {p=1, t=1},		
		WEF_F_Follow	= {p=1, t=1},		
		WEF_F_Greet	= {p=1, t=1},		
		WEF_F_Heal	= {p=1, t=1},		
		WEF_F_Help	= {p=1, t=1},		
		WEF_F_Laugh	= {p=1, t=1},		
		WEF_F_Stop	= {p=1, t=1},		
		WEF_F_Thanks	= {p=1, t=1},		
	},				
	[2] = {				
		DW_Do_not_Swear	= {p=1, t=5},		
		DW_Earth_Death_Scheduled	= {p=10, t=5},		
		DW_Exterminate	= {p=1, t=5},		
		DW_Must_Survive	= {p=1, t=5},		
		DW_Owner_of_Blue_Box	= {p=1, t=5},		
		DW_TARDIS	= {p=1, t=5},		
		DW_Upgrading_is_compulsory	= {p=1, t=5},		
		DW_Weakest_Link	= {p=1, t=5},		
	},				
	[3] = {				
		HEF_F_Agree	= {p=1, t=1},		
		HEF_F_Disagree	= {p=1, t=1},		
		HEF_F_Follow	= {p=1, t=1},		
		HEF_F_Greet	= {p=1, t=1},		
		HEF_F_Heal	= {p=1, t=1},		
		HEF_F_Help	= {p=1, t=1},		
		HEF_F_Laugh	= {p=1, t=1},		
		HEF_F_Stop	= {p=1, t=1},		
		HEF_F_Thanks	= {p=1, t=1},		
	},				
	[4] = {				
		egypt1	= {p=1, t=1},		
		egypt2	= {p=1, t=1},		
		egypt3	= {p=1, t=1},		
	},				
}					
--	90	(40)			
local lootitems = {					
	[119813] = true, 	-- Furry Caged Beast			
	[119810] = true, 	-- Meaty Caged Beast			
	[119814] = true, 	-- Leathery Caged Beast			
	[119815] = true, 	-- Caged Mighty Wolf			
	[119817] = true, 	-- Caged Mighty Riverbeast			
	[119819] = true, 	-- Caged Mighty Clefthoof			
	[2589]    = true,	-- linen-cloth			
	[2592]    = true,	-- wool-cloth			
	[4306]    = true,	-- silk-cloth			
	[4338]    = true,	-- mageweave-cloth			
	[14047]  = true,	-- runecloth			
	[21877]  = true,	-- netherweave-cloth			
	[53010]  = true,	-- embersilk-cloth			
	[33470]  = true,	-- frostweave-cloth			
	[72988]  = true,	-- windwool-cloth			
	[111556]  = true,	-- hexweave-cloth			
}					
--	109	(19)			
local deb_tex = {					
	[1] = "Give me your skin!",				
	[2] = "Pull .,. Pull",				
	[3] = "Wack .,. Wack",				
	[4] = "Whats that",				
	[5] = "say ",				
	[6] = "tug  tug ",				
}					
local m = { pet = 5, list = 5, }					
--	119	(9)			
-- chat funtions					
function addon:chatMsg(msg) 					
	addon:chatMsg1(addonName..": "..msg)				
end					
function addon:chatMsg1(msg) 					
	DEFAULT_CHAT_FRAME:AddMessage(msg)				
end					
--	127	(8)			
function addon:doWork(u_skill)					
	if not settings or not settings.enabled then return end				
	local now = GetTime()				
	local pause = settings.playfrequency				
	if now < (addon.nextplay or 0) then return end				
	addon.pet_summon = pet_n[settings.pet][1]				
	-- print("hello 1")				
	if settings.summon then				
		addon:pet_call()			
	end				
	-- print("hello 2")				
	if settings.sound then				
		local user = 0			
		user = (settings.link and settings.pet or settings.list)			
		pause = addon:soundplay(user,pause)			
	end				
	-- print("hello 3")				
	if settings.say then				
		addon:petsay(u_skill)			
	end				
	-- print("hello 4")				
	addon.nextplay = now + pause				
end					
--	148	(21)			
function addon:pet_out()					
	local petName				
	local pet_gu = addon:pet_type()				
	if addon:pet_av(pet_gu) then 				
		local pet_spe, petHand, _, _, _, _, _, petRace  = C_PetJournal.GetPetInfoByPetID(pet_gu)			
		if not petHand then petHand = petRace end			
		petName=petHand			
	else				
		petName = "a voice from a distance"			
	end				
	return petName				
end					
--	161	(13)			
function addon:pet_av(pet_f)					
	if pet_f == 0 then				
		return (C_PetJournal.GetSummonedPetGUID() and true or false)			
	else				
		if C_PetJournal.PetIsSummonable(pet_f) then			
			return true		
		else			
			msg= (C_PetJournal.GetPetStats(pet_f) and "Your pet is dead best revive it" or "Unknown Pet please change pet and report")		
					
			addon:chatMsg(msg)		
			return false		
		end			
	end				
end					
--	177	(16)			
function addon:pet_type()					
	local pet_gu = addon.pet_summon				
	local pet = (addon:pet_av(0) and C_PetJournal.GetSummonedPetGUID() or 0)			
	if not (settings.summon and addon:pet_av(pet_gu)) then pet_gu=pet end				
	return pet_gu, pet				
end					
--	187	(10)			
function addon:pet_call()					
	local pet_want = addon.pet_summon				
	if not addon:pet_av(pet_want) then return end				
	local _,pet = addon:pet_type()				
	if pet ~= pet_want then				
		C_PetJournal.SummonPetByGUID(pet_want)			
	end				
end					
--	196	(9)			
function addon:petsay(u_skill)					
	local msg = deb_tex[u_skill]				
	SendChatMessage("hears "..addon:pet_out().." say ".."'"..msg.."'","EMOTE");				
end					
--	201	(5)			
function addon:soundplay(pet_f,pause)					
	local soundtable = {}				
	local soundsum = 0				
	for name, data in pairs(soundfiles[pet_f]) do				
		local soundname = ("Interface\\AddOns\\"..addonName.."\\sound\\"..name..".mp3")			
		table.insert(soundtable, {			
			soundname, data.p, data.t		
			})		
		soundsum = soundsum + data.p			
	end				
	local roll = math.random(soundsum)				
	for i,e in ipairs(soundtable) do				
		local f,p,t = unpack(e)			
		roll = roll - p			
		if roll <= 0 then			
			PlaySoundFile(f, "Master")		
			pause = math.max(pause, t)		
			return pause		
		end			
	end				
end					
--	223	(22)			
function addon:Loot_Call(msg)					
	local itemstr = LOOT_ITEM_PUSHED_SELF:gsub("%%s","%(.*%)") -- for Skinning				
	local itemstr2 = LOOT_ITEM_SELF:gsub("%%s","%(.*%)") -- for tailery				
	local message = msg or ""				
	local link = message:match(itemstr)				
	local link2 = message:match(itemstr2) --				
	local hold				
	if (link) then hold = link else hold = link2 end				
	local id = hold and tonumber(hold:match("\124Hitem:(%d+):"))				
	if id and lootitems[id] then				
		addon:doWork(4)			
	end				
end					
--	237	(14)			
function addon:Spell_Call(unitID, spell)					
	if unitID == "player" then				
		local fishing = GetSpellInfo(7620)			
		local skinning = GetSpellInfo(8613)			
		local find_herbs = GetSpellInfo(2368)	
		local find_mine = GetSpellInfo(2575)			
		local spell_id = 0			
		if spell == skinning then			
			spell_id = 1		
		elseif spell == find_herbs or spell == "Herbalism" then			
			spell_id = 2		
		elseif spell == find_mine then			
			spell_id = 3		
		elseif spell == fishing then			
			spell_id = 6		
		end			
		if spell_id ~= 0 then addon:doWork(spell_id) end			
	end				
end					
--	257	(20)			
local function frame_OnEvent(self,event,...)					
	if event == "ADDON_LOADED" and select(1,...) == addonName then				
		addon:chatMsg(version)			
		if not Profession_RPSettings then			
			Profession_RPSettings = {} 		
		end			
		settings = Profession_RPSettings			
		for k,v in pairs(defaults) do			
			if settings[k] == nil then		
				settings[k] = v	
			end		
		end			
	elseif event == "UNIT_SPELLCAST_START" then				
		local unitID, spell = ...			
		addon:Spell_Call(unitID, spell)			
	elseif event == "CHAT_MSG_LOOT" then				
		local arg1 = ...			
		addon:Loot_Call(arg1)	
	elseif event == "CHAT_MSG_WHISPER" and settings.debug then
		addon:doWork(3)			
	end				
end					
--	281	(24)			
function addon:SlashHandler(msg)					
	if not msg then return end				
					
	local msgLower = msg:lower()				
	local wordsLower = addon:GetWords(msgLower)				
	local size = addon:TableSize(wordsLower)				
	local cmd = wordsLower[0]				
					
	if cmd == "on" then				
		settings.enabled = true			
		addon:chatMsg("Enabled.")			
	elseif cmd == "off" then				
		settings.enabled = false			
		addon:chatMsg("Disabled.")			
	elseif cmd == "sound" or cmd == "summon" or cmd == "say"				
		or cmd == "link" or cmd == "debug" then			
			settings[cmd] = not settings[cmd]		
			addon:chatMsg(cmd.." "..(settings[cmd] and "enabled." or "disabled."))		
	elseif cmd == "list" or cmd == "pet" then				
		if (size>1) then			
			if not pet_n[tonumber(wordsLower[1])] then		
				Msg1=("Sorry you cannot go over "..m[cmd])	
			else		
				Msg1=(cmd.." now #" .. wordsLower[1])	
				settings[cmd]=tonumber(wordsLower[1])	
			end		
			addon:chatMsg(Msg1)		
		end			
	elseif cmd == "test" and settings.debug then				
		if addon:pet_av(0) then 			
			local _,pet = addon:pet_type()		
			print ("your pet is "..pet)		
		else	--	C_PetJournal.GetOwnedBattlePetString(speciesId)	
			print ("you don't have a pet out")		
		end			
	else				
		addon:ChatHelp()			
	end				
end					
--	321	(40)			
function addon:ChatHelp()					
	local c = 	{			
		[0] = ("Usage: "..addonsls.." [ "),			
		[1] = " | ",			
		[2] = "on",			
		[3] = "off",			
		[4] = " = ",			
		[5] = " ]",			
	}				
	local d = 	{			
		[1] = 	{		
			[1] =	(settings.enabled and c[2] or c[3]),	
			[2] =	"enabled",	
		},			
		[2] =	{		
			[1] =	(settings.summon and c[2] or c[3]),	
			[2] =	"summon",	
		},			
		[3] =	{		
			[1] =	(settings.say and c[2] or c[3]),	
			[2] =	"say",	
		},			
		[4] =	{		
			[1] =	(settings.sound and c[2] or c[3]),	
			[2] =	"sound",	
		},			
		[5] =	{		
			[1] =	(settings.link and c[2] or c[3]),	
			[2] =	"link",	
		},			
		[6] =	{		
			[1] =	settings.pet,	
			[2] =	"pet",	
		},			
		[7] =	{		
			[1] =	settings.list,	
			[2] =	"list",	
		},			
	}				
	local e =	{			
		[0] =	(c[2]..c[1]..c[3]..c[1]),		
		[1] =	(c[4]..d[1][1]..c[1]),		
		[2] =	(c[4]..d[2][1]..c[1]),		
		[3] =	(c[4]..d[3][1]),		
		[4] =	(c[4]..d[4][1]..c[1]),		
		[5] =	(c[4]..d[5][1]),		
		[6] =	(c[4]..d[6][1]..c[1]),		
		[7] =	(c[4]..d[7][1]),		
		}			
					
	addon:chatMsg(c[0]..e[0]..d[2][2]..e[2]..d[3][2]..e[3]..c[5])				
	addon:chatMsg(c[0]    ..   d[4][2]..e[4]..d[5][2]..e[5]..c[5])				
	addon:chatMsg(c[0]    ..   d[6][2]..e[6]..d[7][2]..e[7]..c[5])				
end					
--	376	(51)			
function addon:TableSize(info)					
	local result = 0				
	if info then				
		for item in pairs(info) do result = result + 1 end			
	end				
	return result				
end					
--	384	(57)			
function addon:GetWords(str)					
	local ret = {};				
	local pos=0;				
	local index=0				
	while(true) do				
		local word;			
		_,pos,word=string.find(str, "^ *([^%s]+) *", pos+1);			
		if(not word) then			
			return ret;		
		end			
		ret[index]=word			
		index = index+1			
	end				
end					
--	399	(15)			
local frame = CreateFrame("Button", addonName.."HiddenFrame", UIParent)					
frame:SetScript("OnEvent", frame_OnEvent)					
frame:RegisterEvent("ADDON_LOADED")					
frame:RegisterEvent("UNIT_SPELLCAST_START")					
frame:RegisterEvent("CHAT_MSG_LOOT")					
frame:RegisterEvent("CHAT_MSG_WHISPER");					
--	406	(7)			
-- slash cmd function					
	hash_SlashCmdList[addonsls] = nil				
	SLASH_Profession_RP1 = addonsls				
	SlashCmdList[addonName] = function(msg)				
		addon:SlashHandler(msg)			
	end				
-- end slash cmd		(7)